#pragma once

#include <gtkmm/application.h>
#include <glibmm/ustring.h>
#include "MainWindow.hpp"
#include "PrefWindow.hpp"
#include "core.hpp"

namespace components {

    // Класс приложения
    class App: public Gtk::Application
    {

    public:
        // Создаёт ссылку на приложение
        static Glib::RefPtr<App> create(core::Core* appcore);

    protected:
        App(core::Core* appcore);

        void on_startup() override;

        void on_activate() override;

        // Закрывает приложение
        void onActionQuit();

        // ПОказывает диалог настроек
        void onActionPrefs();

        // Копирует ID текущего видео
        void onActionCopyYTID();

        // Копирует ссылку на видео
        void onActionCopyYTLink();

        // Создаёт главное окно приложения
        MainWindow* createMainWindow();

        // Создаёт окно настроек приложения
        PrefWindow* createPrefWindow();

        // Ссылка на главное окно
        MainWindow* m_main_window;

        // Ссылка на ядро
        core::Core* m_appcore;
    };
}
